import numpy as np
import matplotlib.pyplot as plt
from time import perf_counter as clock

def methode(f,a,b,y0,n):
    y=y0
    t=a
    pas=(b-a)/(n-1)
    liste_y=[y0]
    liste_t=[a]
    while t+pas<=b:
        y=y+pas*f(y,t)
        liste_y.append(y)
        t=t+pas
        liste_t.append(t)
    return liste_t,liste_y

w0,x0=5,1
print("Analyse de la performance d'une méthode de résolution d'une équation différentielle")
print("On étudie le mouvement d'un ocsillateur harmonique laché en x0=1, sans vitesse initiale")

def oscillateur(Y,t):
    return np.array([Y[1],-w0**2*Y[0]])

def solution(t):
    return x0*np.cos(w0*t)


def DureesFonction(fonction,nmin,nmax,pas,moyennage=1):
    
    def moyenne(valeurs):
        s=0
        for i in valeurs:
            s+=i
        return s/len(valeurs)    
    
    durees=[]
    n=[]
    for i in range(int(nmin),int(nmax)+1,int(pas)):
         n.append(i)
         t=[]
         for k in range(moyennage):
            ti=clock()
            fonction(i)
            tf=clock()
            t.append(tf-ti)
         durees.append(moyenne(t))
    return n,durees


tmax=10

print("étude graphique")
for k in range(3,7):    
    #Execution de la résolution numérique
    n=int(10**k)
    approx=methode(oscillateur,0,tmax,[x0,0],n)
    
    #Extraction dates et solution exacte 
    t=approx[0]
    sol=solution(np.array(t))
    
    #Extraction x approchés
    x=np.zeros(len(t))    
    for i in range(len(t)):
        x[i]=approx[1][i][0]
    
    #Tracé du graphe
    plt.figure(k)
    plt.plot(t,x,label='sol approchée') 
    plt.plot(t,sol,'-r',label='sol exacte')
    plt.legend(loc=2)
    plt.xlabel('temps (en s)')
    plt.ylabel('x(t)')
    plt.title("Tracés pour "+ str(n)+" itérations")
    plt.show()
    
print("évolution du temps de calcul")

def AdaptMethode(n):
     return methode(oscillateur,0,tmax,[x0,0],n)
     

n,t=DureesFonction(AdaptMethode,1e3,1e5,5000)

plt.figure(0)
plt.plot(n,t,'.b')
plt.xlabel("Nombre d'itérations")
plt.ylabel("Durée du calcul")
plt.title( chr(201)+"volution de la durée du calcul en fonction du nombre d'itérations")
plt.show()


